/**
 * Adapted from ReactCSSTransitionGroupChild.js by Facebook
 *
 * @providesModule ReactCSSTransitionReplaceChild
 */

'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _fbjsLibCSSCore = require('fbjs/lib/CSSCore');

var _fbjsLibCSSCore2 = _interopRequireDefault(_fbjsLibCSSCore);

var _reactLibReactTransitionEvents = require('react/lib/ReactTransitionEvents');

var _reactLibReactTransitionEvents2 = _interopRequireDefault(_reactLibReactTransitionEvents);

// We don't remove the element from the DOM until we receive an animationend or
// transitionend event. If the user screws up and forgets to add an animation
// their node will be stuck in the DOM forever, so we detect if an animation
// does not start and if it doesn't, we just call the end listener immediately.
var TICK = 17;

var ReactCSSTransitionReplaceChild = (function (_React$Component) {
  _inherits(ReactCSSTransitionReplaceChild, _React$Component);

  function ReactCSSTransitionReplaceChild() {
    var _this = this;

    _classCallCheck(this, ReactCSSTransitionReplaceChild);

    _get(Object.getPrototypeOf(ReactCSSTransitionReplaceChild.prototype), 'constructor', this).apply(this, arguments);

    this.flushClassNameQueue = function () {
      if (_this._mounted) {
        _this.classNameQueue.forEach(function (className) {
          return _fbjsLibCSSCore2['default'].addClass(_reactDom2['default'].findDOMNode(_this), className);
        });
      }
      _this.classNameQueue.length = 0;
      _this.timeout = null;
    };
  }

  _createClass(ReactCSSTransitionReplaceChild, [{
    key: 'transition',
    value: function transition(animationType, finishCallback, userSpecifiedDelay) {
      var node = _reactDom2['default'].findDOMNode(this);

      if (!node) {
        if (finishCallback) {
          finishCallback();
        }
        return;
      }

      var className = this.props.name[animationType] || this.props.name + '-' + animationType;
      var activeClassName = this.props.name[animationType + 'Active'] || className + '-active';
      var timeout = null;

      var endListener = function endListener(e) {
        if (e && e.target !== node) {
          return;
        }

        clearTimeout(timeout);

        _fbjsLibCSSCore2['default'].removeClass(node, className);
        _fbjsLibCSSCore2['default'].removeClass(node, activeClassName);

        _reactLibReactTransitionEvents2['default'].removeEndEventListener(node, endListener);

        // Usually this optional callback is used for informing an owner of
        // a leave animation and telling it to remove the child.
        if (finishCallback) {
          finishCallback();
        }
      };

      _fbjsLibCSSCore2['default'].addClass(node, className);

      // Need to do this to actually trigger a transition.
      this.queueClass(activeClassName);

      // If the user specified a timeout delay.
      if (userSpecifiedDelay) {
        // Clean-up the animation after the specified delay
        timeout = setTimeout(endListener, userSpecifiedDelay);
      } else {
        // DEPRECATED: this listener will be removed in a future version of react
        _reactLibReactTransitionEvents2['default'].addEndEventListener(node, endListener);
      }
    }
  }, {
    key: 'queueClass',
    value: function queueClass(className) {
      this.classNameQueue.push(className);

      if (!this.timeout) {
        this.timeout = setTimeout(this.flushClassNameQueue, TICK);
      }
    }
  }, {
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.classNameQueue = [];
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this._mounted = true;
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      delete this._mounted;
      if (this.timeout) {
        clearTimeout(this.timeout);
      }
    }
  }, {
    key: 'componentWillAppear',
    value: function componentWillAppear(done) {
      if (this.props.appear) {
        this.transition('appear', done, this.props.appearTimeout);
      } else {
        done();
      }
    }
  }, {
    key: 'componentWillEnter',
    value: function componentWillEnter(done) {
      if (this.props.enter) {
        this.transition('enter', done, this.props.enterTimeout);
      } else {
        done();
      }
    }
  }, {
    key: 'componentWillLeave',
    value: function componentWillLeave(done) {
      if (this.props.leave) {
        this.transition('leave', done, this.props.leaveTimeout);
      } else {
        done();
      }
    }
  }, {
    key: 'componentDidEnter',
    value: function componentDidEnter() {
      this.props.onEntered();
    }
  }, {
    key: 'componentDidLeave',
    value: function componentDidLeave() {
      this.props.onLeft();
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2['default'].Children.only(this.props.children);
    }
  }], [{
    key: 'propTypes',
    value: {
      name: _react2['default'].PropTypes.oneOfType([_react2['default'].PropTypes.string, _react2['default'].PropTypes.shape({
        enter: _react2['default'].PropTypes.string,
        leave: _react2['default'].PropTypes.string,
        active: _react2['default'].PropTypes.string
      }), _react2['default'].PropTypes.shape({
        enter: _react2['default'].PropTypes.string,
        enterActive: _react2['default'].PropTypes.string,
        leave: _react2['default'].PropTypes.string,
        leaveActive: _react2['default'].PropTypes.string,
        appear: _react2['default'].PropTypes.string,
        appearActive: _react2['default'].PropTypes.string
      })]).isRequired,

      // Once we require timeouts to be specified, we can remove the
      // boolean flags (appear etc.) and just accept a number
      // or a bool for the timeout flags (appearTimeout etc.)
      appear: _react2['default'].PropTypes.bool,
      enter: _react2['default'].PropTypes.bool,
      leave: _react2['default'].PropTypes.bool,
      appearTimeout: _react2['default'].PropTypes.number,
      enterTimeout: _react2['default'].PropTypes.number,
      leaveTimeout: _react2['default'].PropTypes.number
    },
    enumerable: true
  }]);

  return ReactCSSTransitionReplaceChild;
})(_react2['default'].Component);

exports['default'] = ReactCSSTransitionReplaceChild;
module.exports = exports['default'];